
#ifndef _VEC3F
#define _VEC3F

class Vec3f
{
	float _vec[3];
public:
	Vec3f(){_vec[0]=0;_vec[1]=0;_vec[2]=0;};
	Vec3f(float in[3])
	{
		_vec[0] = in[0]; _vec[1] = in[1]; _vec[2] = in[2];
	};
	Vec3f(float x, float y, float z)
	{
		_vec[0] = x; _vec[1] = y; _vec[2] = z;
	};
	Vec3f(Vec3f &in)
	{
		_vec[0] = in._vec[0]; _vec[1] = in._vec[1]; _vec[2] = in._vec[2];
	};
	Vec3f operator+(const Vec3f &in)
	{
		Vec3f out;
		out[0] = _vec[0] + in._vec[0];
		out[1] = _vec[1] + in._vec[1];
		out[2] = _vec[2] + in._vec[2];
		return out;
	}
	Vec3f operator-(const Vec3f &in)
	{
		Vec3f out;
		out[0] = _vec[0] - in._vec[0];
		out[1] = _vec[1] - in._vec[1];
		out[2] = _vec[2] - in._vec[2];
		return out;
	}
	Vec3f operator*(const Vec3f in)
	{
		Vec3f out;
		out[0] = _vec[0] * in._vec[0];
		out[1] = _vec[1] * in._vec[1];
		out[2] = _vec[2] * in._vec[2];
		return out;
	}
	Vec3f operator*(const float in)
	{
		Vec3f out;
		out[0] = _vec[0] * in;
		out[1] = _vec[1] * in;
		out[2] = _vec[2] * in;
		return out;
	}

	float& operator[](int i)
	{
		return _vec[i];
	}

	Vec3f cross(const Vec3f in)
	{
		Vec3f out;
		out[0] = _vec[1]*in._vec[2] - _vec[2]*in._vec[1];
		out[1] = _vec[2]*in._vec[0] - _vec[0]*in._vec[2];
		out[2] = _vec[0]*in._vec[1] - _vec[1]*in._vec[0];
		return out;    
	}
	float length()
	{
		return sqrt(_vec[0]*_vec[0] + _vec[1]*_vec[1] + _vec[2]*_vec[2]);
	}
	void normalize()
	{
		float tmp = sqrt(_vec[0]*_vec[0] + _vec[1]*_vec[1] + _vec[2]*_vec[2]);
		if (tmp <= FLT_EPSILON) return;
		_vec[0]/=tmp;
		_vec[1]/=tmp;
		_vec[2]/=tmp;
	}

	void limit(float max_length) 
	{
		float tmp = length();
		if (tmp > max_length) {
			_vec[0]/=tmp;
			_vec[1]/=tmp;
			_vec[2]/=tmp;
		}
	}
};

#endif
